<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: Allocator.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Allocator.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// -----------</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// Allocator.h</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">// -----------</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;</div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="preprocessor">#ifndef Allocator_h</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#define Allocator_h</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;</div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment">// --------</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment">// includes</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment">// --------</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;</div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &lt;cassert&gt;</span>   <span class="comment">// assert</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &lt;cstddef&gt;</span>   <span class="comment">// ptrdiff_t, size_t</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &lt;new&gt;</span>       <span class="comment">// bad_alloc, new</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#include &lt;stdexcept&gt;</span> <span class="comment">// invalid_argument</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment">// ---------</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment">// Allocator</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment">// ---------</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, std::<span class="keywordtype">size_t</span> N&gt;</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;</div><div class="line"><a name="l00023"></a><span class="lineno"><a class="line" href="classmy__allocator.html">   23</a></span>&#160;<span class="keyword">class </span><a class="code" href="classmy__allocator.html">my_allocator</a> {</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    <span class="comment">// -----------</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    <span class="comment">// operator ==</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    <span class="comment">// -----------</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    <span class="keyword">friend</span> <span class="keywordtype">bool</span> operator == (<span class="keyword">const</span> <a class="code" href="classmy__allocator.html">my_allocator</a>&amp;, <span class="keyword">const</span> <a class="code" href="classmy__allocator.html">my_allocator</a>&amp;) {</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    }                                                   <span class="comment">// this is correct</span></div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    <span class="comment">// -----------</span></div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    <span class="comment">// operator !=</span></div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    <span class="comment">// -----------</span></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <span class="keyword">friend</span> <span class="keywordtype">bool</span> operator != (<span class="keyword">const</span> <a class="code" href="classmy__allocator.html">my_allocator</a>&amp; lhs, <span class="keyword">const</span> <a class="code" href="classmy__allocator.html">my_allocator</a>&amp; rhs) {</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;        <span class="keywordflow">return</span> !(lhs == rhs);</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    }</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <span class="comment">// --------</span></div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    <span class="comment">// typedefs</span></div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    <span class="comment">// --------</span></div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    <span class="keyword">using</span>      value_type = T;</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    <span class="keyword">using</span>       size_type = std::size_t;</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    <span class="keyword">using</span> difference_type = std::ptrdiff_t;</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    <span class="keyword">using</span>       pointer   =       value_type*;</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    <span class="keyword">using</span> const_pointer   = <span class="keyword">const</span> value_type*;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    <span class="keyword">using</span>       reference =       value_type&amp;;</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <span class="keyword">using</span> const_reference = <span class="keyword">const</span> value_type&amp;;</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    <span class="comment">// ---------------</span></div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    <span class="comment">// iterator</span></div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    <span class="comment">// over the blocks</span></div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    <span class="comment">// ---------------</span></div><div class="line"><a name="l00061"></a><span class="lineno"><a class="line" href="classmy__allocator_1_1iterator.html">   61</a></span>&#160;    <span class="keyword">class </span><a class="code" href="classmy__allocator_1_1iterator.html">iterator</a> {</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;        <span class="comment">// operator ==</span></div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;        <span class="keyword">friend</span> <span class="keywordtype">bool</span> operator == (<span class="keyword">const</span> <a class="code" href="classmy__allocator_1_1iterator.html">iterator</a>&amp; lhs, <span class="keyword">const</span> <a class="code" href="classmy__allocator_1_1iterator.html">iterator</a>&amp; rhs) {</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;            <span class="keywordflow">return</span> (lhs._p) == (rhs._p);</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;        }</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;        <span class="comment">// operator !=</span></div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;        <span class="keyword">friend</span> <span class="keywordtype">bool</span> operator != (<span class="keyword">const</span> <a class="code" href="classmy__allocator_1_1iterator.html">iterator</a>&amp; lhs, <span class="keyword">const</span> <a class="code" href="classmy__allocator_1_1iterator.html">iterator</a>&amp; rhs) {</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;            <span class="keywordflow">return</span> !(lhs == rhs);</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;        }</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;        <span class="comment">// ----</span></div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;        <span class="comment">// data</span></div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;        <span class="comment">// ----</span></div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;        <span class="keywordtype">int</span>* _p;</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;        <span class="comment">// constructor</span></div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;        <a class="code" href="classmy__allocator_1_1iterator.html">iterator</a> (<span class="keywordtype">int</span>* p) {</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;            _p = p;</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;        }</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;        <span class="comment">// ----------</span></div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;        <span class="comment">// operator *</span></div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;        <span class="comment">// ----------</span></div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;        <span class="keywordtype">int</span>&amp; operator * ()<span class="keyword"> const </span>{</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;            <span class="keywordflow">return</span> *(_p);</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;        }</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;        <span class="comment">// operator ++</span></div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;        <a class="code" href="classmy__allocator_1_1iterator.html">iterator</a>&amp; operator ++ () {</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;        </div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;        <span class="comment">// get value of front sentinel, may be negative, so</span></div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;        <span class="comment">//  we use its absolute value</span></div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;            <span class="keywordtype">int</span> sentinel_value = (*_p) &gt; 0 ? (*_p) : -1 * (*_p);</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;            <span class="keywordtype">char</span> * c = (<span class="keywordtype">char</span> *)(_p);</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;            <span class="comment">// use a char pointer so we can increment sentinel</span></div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;        <span class="comment">//  address by single bytes, as opposed to four</span></div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;        c += sentinel_value + 2 * <span class="keyword">sizeof</span>(int); <span class="comment">// increment sentinel address by stored val</span></div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;            <span class="comment">// plus its own size and the back sentinel&#39;s size</span></div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;            _p = (<span class="keywordtype">int</span> *) c;</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;            <span class="keywordflow">return</span> *<span class="keyword">this</span>;</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;        }</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;        <span class="comment">// operator ++</span></div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;        <a class="code" href="classmy__allocator_1_1iterator.html">iterator</a> operator ++ (<span class="keywordtype">int</span>) {</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;            <a class="code" href="classmy__allocator_1_1iterator.html">iterator</a> x = *<span class="keyword">this</span>;</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;            ++*<span class="keyword">this</span>;</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;            <span class="keywordflow">return</span> x;</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;        }</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;        <span class="comment">// operator --</span></div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;        <a class="code" href="classmy__allocator_1_1iterator.html">iterator</a>&amp; operator -- () {</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;    </div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;        <span class="comment">// same idea as above, except that we are interested in the sentinel of</span></div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;        <span class="comment">// the previous block, bound control is enforced by the allocator object</span></div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;        <span class="comment">// NOT the user</span></div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;            <span class="keywordtype">char</span> * c = (<span class="keywordtype">char</span> *)_p;</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;        <span class="comment">// c should be at the address of the previous block&#39;s sentinel</span></div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;            c -= <span class="keyword">sizeof</span>(int);</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;            <span class="keywordtype">int</span> prev_sent = (*((<span class="keywordtype">int</span> * ) c)) &gt; 0 ? (*((<span class="keywordtype">int</span> * ) c)) : -1 * (*((<span class="keywordtype">int</span> * ) c));</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;        <span class="comment">// c should be at the previous block&#39;s first sentinel</span></div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;            c -= (prev_sent + <span class="keyword">sizeof</span>(int));</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;            _p = (<span class="keywordtype">int</span> *) c;</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;            <span class="keywordflow">return</span> *<span class="keyword">this</span>;</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;        }</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;        <span class="comment">// operator --</span></div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;        <a class="code" href="classmy__allocator_1_1iterator.html">iterator</a> operator -- (<span class="keywordtype">int</span>) {</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;            <a class="code" href="classmy__allocator_1_1iterator.html">iterator</a> x = *<span class="keyword">this</span>;</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;            --*<span class="keyword">this</span>;</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;            <span class="comment">//iterator x = *this;</span></div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;            <span class="keywordflow">return</span> x;</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;        }</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;    };</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;    <span class="comment">// ---------------</span></div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;    <span class="comment">// const_iterator</span></div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;    <span class="comment">// over the blocks</span></div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;    <span class="comment">// ---------------</span></div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;</div><div class="line"><a name="l00167"></a><span class="lineno"><a class="line" href="classmy__allocator_1_1const__iterator.html">  167</a></span>&#160;    <span class="keyword">class </span><a class="code" href="classmy__allocator_1_1const__iterator.html">const_iterator</a> {</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;        <span class="comment">// operator ==</span></div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;        <span class="keyword">friend</span> <span class="keywordtype">bool</span> operator == (<span class="keyword">const</span> <a class="code" href="classmy__allocator_1_1const__iterator.html">const_iterator</a>&amp; lhs, <span class="keyword">const</span> <a class="code" href="classmy__allocator_1_1const__iterator.html">const_iterator</a>&amp; rhs) {</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;            <span class="keywordflow">return</span> (lhs._p) == (rhs._p);</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;        }</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;        <span class="comment">// operator !=</span></div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;        <span class="keyword">friend</span> <span class="keywordtype">bool</span> operator != (<span class="keyword">const</span> <a class="code" href="classmy__allocator_1_1const__iterator.html">const_iterator</a>&amp; lhs, <span class="keyword">const</span> <a class="code" href="classmy__allocator_1_1const__iterator.html">const_iterator</a>&amp; rhs) {</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;            <span class="keywordflow">return</span> !(lhs == rhs);</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;        }</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;</div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;        <span class="comment">// ----</span></div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;        <span class="comment">// data</span></div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;        <span class="comment">// ----</span></div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">int</span>* _p;</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;        <span class="comment">// constructor</span></div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;</div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;        <a class="code" href="classmy__allocator_1_1const__iterator.html">const_iterator</a> (<span class="keyword">const</span> <span class="keywordtype">int</span>* p) {</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;            _p = p;</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;        }</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;        <span class="comment">// ----------</span></div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;        <span class="comment">// operator *</span></div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;        <span class="comment">// ----------</span></div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">int</span>&amp; operator * ()<span class="keyword"> const </span>{</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;            <span class="keywordflow">return</span> *(_p);</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;        }</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;</div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;        <span class="comment">// operator ++</span></div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;        <a class="code" href="classmy__allocator_1_1const__iterator.html">const_iterator</a>&amp; operator ++ () {</div><div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;</div><div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;            <span class="keywordtype">int</span> sentinel_value = (*_p) &gt; 0 ? (*_p) : -1 * (*_p);</div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;            <span class="keywordtype">char</span> * c = (<span class="keywordtype">char</span> *)(_p);</div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;            c += sentinel_value + 2 * <span class="keyword">sizeof</span>(int);</div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;            _p = (<span class="keyword">const</span> <span class="keywordtype">int</span> *) c;</div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;            <span class="keywordflow">return</span> *<span class="keyword">this</span>;</div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;        }</div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;        <span class="comment">// operator ++</span></div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;</div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;        <a class="code" href="classmy__allocator_1_1const__iterator.html">const_iterator</a> operator ++ (<span class="keywordtype">int</span>) {</div><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;            <a class="code" href="classmy__allocator_1_1const__iterator.html">const_iterator</a> x = *<span class="keyword">this</span>;</div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;            ++*<span class="keyword">this</span>;</div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;            <span class="keywordflow">return</span> x;</div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;        }</div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;</div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;        <span class="comment">// operator --</span></div><div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;</div><div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;        <a class="code" href="classmy__allocator_1_1const__iterator.html">const_iterator</a>&amp; operator -- () {</div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;</div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;            <span class="keywordtype">char</span> * c = (<span class="keywordtype">char</span> *)_p;</div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;            c -= <span class="keyword">sizeof</span>(int);</div><div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;            <span class="keywordtype">int</span> prev_sent = (*((<span class="keywordtype">int</span> * ) c)) &gt; 0 ? (*((<span class="keywordtype">int</span> * ) c)) : -1 * (*((<span class="keywordtype">int</span> * ) c));</div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;            c -= (prev_sent + <span class="keyword">sizeof</span>(int));</div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;            _p = (<span class="keywordtype">int</span> *) c;</div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;            <span class="keywordflow">return</span> *<span class="keyword">this</span>;</div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;        }</div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;</div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;        <span class="comment">// operator --</span></div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;        <span class="comment">// -----------</span></div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;</div><div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;        <a class="code" href="classmy__allocator_1_1const__iterator.html">const_iterator</a> operator -- (<span class="keywordtype">int</span>) {</div><div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;            <a class="code" href="classmy__allocator_1_1const__iterator.html">const_iterator</a> x = *<span class="keyword">this</span>;</div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;            --*<span class="keyword">this</span>;</div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;            <span class="keywordflow">return</span> x;</div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;        }</div><div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;    };</div><div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;</div><div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;    <span class="comment">// ----</span></div><div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;    <span class="comment">// data</span></div><div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;    <span class="comment">// ----</span></div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;</div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;    <span class="keywordtype">char</span> a[N];</div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;</div><div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;    <span class="comment">// -----</span></div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;    <span class="comment">// valid</span></div><div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;    <span class="comment">// -----</span></div><div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;</div><div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;    <span class="keywordtype">bool</span> valid ()<span class="keyword"> const </span>{</div><div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;    </div><div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;        <span class="keywordtype">bool</span> prevFree = <span class="keyword">false</span>;</div><div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;        <span class="keywordflow">for</span> (<a class="code" href="classmy__allocator_1_1const__iterator.html">const_iterator</a> block = <a class="code" href="classmy__allocator.html#ada82835ca637793860c0aededc479c88">c_begin</a>(); block != <a class="code" href="classmy__allocator.html#a4fd52159becc17ad21754ad0cc8dcff5">c_end</a>(); ++block) {</div><div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;            <span class="keyword">const</span> <span class="keywordtype">int</span> firstS = *block;</div><div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;            <span class="keywordflow">if</span> (firstS &gt; 0) {</div><div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;                <span class="keywordflow">if</span> (prevFree) <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;        prevFree = <span class="keyword">true</span>;</div><div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;            } <span class="keywordflow">else</span> {prevFree = <span class="keyword">false</span>;}</div><div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;            </div><div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;        <span class="comment">//no matter if block is busy or free, we must always check that both</span></div><div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;            <span class="comment">//sentines match</span></div><div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;            <span class="keywordtype">char</span>* c = (<span class="keywordtype">char</span>*)(&amp;(*block));</div><div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;            <span class="keywordtype">int</span> absFirstSentinel = (firstS) &gt; 0 ? (firstS) : -1 * (firstS);</div><div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;        c += absFirstSentinel + <span class="keyword">sizeof</span>(int);<span class="comment">//change sizeof(int) to SENTINEL_SIZE/2</span></div><div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">int</span> secondS = *((<span class="keyword">const</span> <span class="keywordtype">int</span> *)(c)); </div><div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;        <span class="keywordflow">if</span> (firstS != secondS) <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;        }</div><div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">true</span>;</div><div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;    }</div><div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;</div><div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;    <span class="comment">// -----------</span></div><div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;    <span class="comment">// constructor</span></div><div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;    <span class="comment">// -----------</span></div><div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;</div><div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;<span class="preprocessor">#define SENTINEL_SIZE 8</span></div><div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;<span class="preprocessor">#define OBJ_SIZE sizeof(T)</span></div><div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;</div><div class="line"><a name="l00307"></a><span class="lineno"><a class="line" href="classmy__allocator.html#ae072d6037f9f72b54303533033ed188d">  307</a></span>&#160;    <a class="code" href="classmy__allocator.html#ae072d6037f9f72b54303533033ed188d">my_allocator</a> () {</div><div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;</div><div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;        <span class="comment">// bad alloc if not enough space for a single T     </span></div><div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;    <span class="keywordflow">if</span> (N &lt; <span class="keyword">sizeof</span>(T) + (2 * <span class="keyword">sizeof</span>(<span class="keywordtype">int</span>))) <span class="keywordflow">throw</span> std::bad_alloc();</div><div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;        (*this)[0] = N - SENTINEL_SIZE;</div><div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;        (*this)[N-SENTINEL_SIZE/2] = N - SENTINEL_SIZE;</div><div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;    <a class="code" href="classmy__allocator_1_1iterator.html">iterator</a> i = <a class="code" href="classmy__allocator.html#a83f5d94cab506e1f9858c24f3eaadbd4">i_end</a>();</div><div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;        assert(valid());</div><div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;    }</div><div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;</div><div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;    <a class="code" href="classmy__allocator.html#ae072d6037f9f72b54303533033ed188d">my_allocator</a>             (<span class="keyword">const</span> <a class="code" href="classmy__allocator.html">my_allocator</a>&amp;) = <span class="keywordflow">default</span>;</div><div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;    ~<a class="code" href="classmy__allocator.html">my_allocator</a>            ()                    = <span class="keywordflow">default</span>;</div><div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;    <a class="code" href="classmy__allocator.html">my_allocator</a>&amp; operator = (<span class="keyword">const</span> <a class="code" href="classmy__allocator.html">my_allocator</a>&amp;) = <span class="keywordflow">default</span>;</div><div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;</div><div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;    <span class="comment">// --------</span></div><div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;    <span class="comment">// allocate</span></div><div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;    <span class="comment">// --------</span></div><div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;    <span class="comment">// Sets both sentinels for a given block to busy</span></div><div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;</div><div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;    <span class="keywordtype">void</span> negate_sentinels (<a class="code" href="classmy__allocator_1_1iterator.html">iterator</a> &amp;block)</div><div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;    {</div><div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;        <span class="comment">// change last sentinel to a negative</span></div><div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;        <span class="keywordtype">char</span> * c = (<span class="keywordtype">char</span> *) (&amp;(*(block)));</div><div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;</div><div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;        c += *block + (SENTINEL_SIZE / 2);</div><div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;        <span class="keywordtype">int</span> * p = (<span class="keywordtype">int</span> *)(&amp;(*c));</div><div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;        *p = -1 * (*block);</div><div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;</div><div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;        <span class="comment">// change first sentinel to a negativei</span></div><div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;    <span class="comment">// must do it last otherwise we would</span></div><div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;    <span class="comment">// increment c by a negative value</span></div><div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;        *block = -1 * (*block);</div><div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;    }</div><div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;</div><div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;    <span class="comment">// Sets both sentinels for a given block to set_size</span></div><div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;    <span class="keywordtype">void</span> set_sentinels (<a class="code" href="classmy__allocator_1_1iterator.html">iterator</a> &amp;block, <span class="keywordtype">int</span> set_size)</div><div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;    {</div><div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;        <span class="comment">// change first sentineli</span></div><div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;    <span class="comment">// we must perform this change first to ensure that</span></div><div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;    <span class="comment">// the address of our second sentinel is correct</span></div><div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;        *block = set_size;</div><div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;</div><div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;        <span class="comment">// change last sentinel</span></div><div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;        <span class="keywordtype">char</span> * c = (<span class="keywordtype">char</span> *) (&amp;(*(block)));</div><div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;        c += *block + (SENTINEL_SIZE / 2);</div><div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160;        <span class="keywordtype">int</span> * p = (<span class="keywordtype">int</span> *)(&amp;(*c));</div><div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;        *p = set_size;</div><div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;    }</div><div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;</div><div class="line"><a name="l00364"></a><span class="lineno"><a class="line" href="classmy__allocator.html#ac2bd3b32769707802cb8ff29f4c257bc">  364</a></span>&#160;    pointer <a class="code" href="classmy__allocator.html#ac2bd3b32769707802cb8ff29f4c257bc">allocate</a> (size_type num_objects) {</div><div class="line"><a name="l00365"></a><span class="lineno">  365</span>&#160;</div><div class="line"><a name="l00366"></a><span class="lineno">  366</span>&#160;        <span class="comment">//valid alloc must be at leat 1 (or sizeof(T) bytes)</span></div><div class="line"><a name="l00367"></a><span class="lineno">  367</span>&#160;        <span class="keywordflow">if</span> (num_objects &lt; 1)</div><div class="line"><a name="l00368"></a><span class="lineno">  368</span>&#160;            <span class="keywordflow">throw</span> std::bad_alloc();</div><div class="line"><a name="l00369"></a><span class="lineno">  369</span>&#160;    assert(num_objects &gt;= 1);</div><div class="line"><a name="l00370"></a><span class="lineno">  370</span>&#160;</div><div class="line"><a name="l00371"></a><span class="lineno">  371</span>&#160;    <span class="comment">// raw amount of bytes needed</span></div><div class="line"><a name="l00372"></a><span class="lineno">  372</span>&#160;        <span class="keywordtype">int</span> space_needed = (num_objects * OBJ_SIZE) + SENTINEL_SIZE;</div><div class="line"><a name="l00373"></a><span class="lineno">  373</span>&#160;</div><div class="line"><a name="l00374"></a><span class="lineno">  374</span>&#160;        <span class="comment">// look for a free block</span></div><div class="line"><a name="l00375"></a><span class="lineno">  375</span>&#160;        <span class="keywordtype">bool</span> block_allocated = <span class="keyword">false</span>;<span class="comment">// if no available block, throw error</span></div><div class="line"><a name="l00376"></a><span class="lineno">  376</span>&#160;        <a class="code" href="classmy__allocator_1_1iterator.html">iterator</a> block = <a class="code" href="classmy__allocator.html#a0d633e247b8093a96a1fd7d71fe0a6ab">i_begin</a>();</div><div class="line"><a name="l00377"></a><span class="lineno">  377</span>&#160;        <a class="code" href="classmy__allocator_1_1iterator.html">iterator</a> result = block;</div><div class="line"><a name="l00378"></a><span class="lineno">  378</span>&#160;        </div><div class="line"><a name="l00379"></a><span class="lineno">  379</span>&#160;    <span class="keywordflow">for</span> (block; block != <a class="code" href="classmy__allocator.html#a83f5d94cab506e1f9858c24f3eaadbd4">i_end</a>() &amp;&amp; !block_allocated; ++block)</div><div class="line"><a name="l00380"></a><span class="lineno">  380</span>&#160;        {</div><div class="line"><a name="l00381"></a><span class="lineno">  381</span>&#160;            <span class="comment">// check to see if current block has enough space</span></div><div class="line"><a name="l00382"></a><span class="lineno">  382</span>&#160;            <span class="keywordtype">int</span> block_size = *block + SENTINEL_SIZE;<span class="comment">// raw bytes available</span></div><div class="line"><a name="l00383"></a><span class="lineno">  383</span>&#160;</div><div class="line"><a name="l00384"></a><span class="lineno">  384</span>&#160;            <span class="keywordflow">if</span> (block_size == space_needed)</div><div class="line"><a name="l00385"></a><span class="lineno">  385</span>&#160;            {</div><div class="line"><a name="l00386"></a><span class="lineno">  386</span>&#160;        <span class="comment">// requested exact amount of space available in this block</span></div><div class="line"><a name="l00387"></a><span class="lineno">  387</span>&#160;                negate_sentinels(block);</div><div class="line"><a name="l00388"></a><span class="lineno">  388</span>&#160;        assert(*block &lt; 0 &amp;&amp; *block == -1 * (space_needed - SENTINEL_SIZE));</div><div class="line"><a name="l00389"></a><span class="lineno">  389</span>&#160;                block_allocated = <span class="keyword">true</span>;</div><div class="line"><a name="l00390"></a><span class="lineno">  390</span>&#160;                result = block;</div><div class="line"><a name="l00391"></a><span class="lineno">  391</span>&#160;            }</div><div class="line"><a name="l00392"></a><span class="lineno">  392</span>&#160;            <span class="keywordflow">else</span> <span class="keywordflow">if</span> (block_size &gt; space_needed)</div><div class="line"><a name="l00393"></a><span class="lineno">  393</span>&#160;            {</div><div class="line"><a name="l00394"></a><span class="lineno">  394</span>&#160;                <span class="keywordtype">int</span> space_left = block_size - space_needed;</div><div class="line"><a name="l00395"></a><span class="lineno">  395</span>&#160;</div><div class="line"><a name="l00396"></a><span class="lineno">  396</span>&#160;                <span class="comment">//edge case, so we just give the user a little</span></div><div class="line"><a name="l00397"></a><span class="lineno">  397</span>&#160;        <span class="comment">// extra space</span></div><div class="line"><a name="l00398"></a><span class="lineno">  398</span>&#160;                <span class="keywordflow">if</span> (space_left &lt; SENTINEL_SIZE + OBJ_SIZE)</div><div class="line"><a name="l00399"></a><span class="lineno">  399</span>&#160;                {</div><div class="line"><a name="l00400"></a><span class="lineno">  400</span>&#160;                    negate_sentinels(block);</div><div class="line"><a name="l00401"></a><span class="lineno">  401</span>&#160;                }</div><div class="line"><a name="l00402"></a><span class="lineno">  402</span>&#160;                <span class="keywordflow">else</span></div><div class="line"><a name="l00403"></a><span class="lineno">  403</span>&#160;                {</div><div class="line"><a name="l00404"></a><span class="lineno">  404</span>&#160;                    <span class="comment">// setting first section of block to busy</span></div><div class="line"><a name="l00405"></a><span class="lineno">  405</span>&#160;                    *block = space_needed - SENTINEL_SIZE;</div><div class="line"><a name="l00406"></a><span class="lineno">  406</span>&#160;                    negate_sentinels(block);</div><div class="line"><a name="l00407"></a><span class="lineno">  407</span>&#160;                    <span class="comment">// increment so we can check the block that succeeds us,</span></div><div class="line"><a name="l00408"></a><span class="lineno">  408</span>&#160;            <span class="comment">//  set that to temp</span></div><div class="line"><a name="l00409"></a><span class="lineno">  409</span>&#160;            ++block;</div><div class="line"><a name="l00410"></a><span class="lineno">  410</span>&#160;                    <a class="code" href="classmy__allocator_1_1iterator.html">iterator</a> temp = block;</div><div class="line"><a name="l00411"></a><span class="lineno">  411</span>&#160;                    <span class="comment">// set the sentinels of the new free block created after</span></div><div class="line"><a name="l00412"></a><span class="lineno">  412</span>&#160;            <span class="comment">//  &#39;block&#39;</span></div><div class="line"><a name="l00413"></a><span class="lineno">  413</span>&#160;            set_sentinels(temp, space_left - SENTINEL_SIZE);</div><div class="line"><a name="l00414"></a><span class="lineno">  414</span>&#160;                    <span class="comment">// set block to previous value</span></div><div class="line"><a name="l00415"></a><span class="lineno">  415</span>&#160;            --block;</div><div class="line"><a name="l00416"></a><span class="lineno">  416</span>&#160;            <span class="comment">//make sure block has returned to what it was correctly</span></div><div class="line"><a name="l00417"></a><span class="lineno">  417</span>&#160;            assert(*block == -1 * (space_needed - SENTINEL_SIZE));</div><div class="line"><a name="l00418"></a><span class="lineno">  418</span>&#160;                }</div><div class="line"><a name="l00419"></a><span class="lineno">  419</span>&#160;                result = block;</div><div class="line"><a name="l00420"></a><span class="lineno">  420</span>&#160;                block_allocated = <span class="keyword">true</span>;</div><div class="line"><a name="l00421"></a><span class="lineno">  421</span>&#160;            }</div><div class="line"><a name="l00422"></a><span class="lineno">  422</span>&#160;        }</div><div class="line"><a name="l00423"></a><span class="lineno">  423</span>&#160;</div><div class="line"><a name="l00424"></a><span class="lineno">  424</span>&#160;        <span class="comment">//if a block was never found throw an exception</span></div><div class="line"><a name="l00425"></a><span class="lineno">  425</span>&#160;        <span class="keywordflow">if</span> (!block_allocated)</div><div class="line"><a name="l00426"></a><span class="lineno">  426</span>&#160;            <span class="keywordflow">throw</span> std::bad_array_new_length();</div><div class="line"><a name="l00427"></a><span class="lineno">  427</span>&#160;        assert(valid());</div><div class="line"><a name="l00428"></a><span class="lineno">  428</span>&#160;    <span class="comment">// add one byte because the user should not have access to the sentinel</span></div><div class="line"><a name="l00429"></a><span class="lineno">  429</span>&#160;        <span class="keywordflow">return</span> (pointer)(&amp;(*result) + 1);</div><div class="line"><a name="l00430"></a><span class="lineno">  430</span>&#160;    }</div><div class="line"><a name="l00431"></a><span class="lineno">  431</span>&#160;</div><div class="line"><a name="l00432"></a><span class="lineno">  432</span>&#160;    <span class="comment">// ---------</span></div><div class="line"><a name="l00433"></a><span class="lineno">  433</span>&#160;    <span class="comment">// construct</span></div><div class="line"><a name="l00434"></a><span class="lineno">  434</span>&#160;    <span class="comment">// ---------</span></div><div class="line"><a name="l00435"></a><span class="lineno">  435</span>&#160;</div><div class="line"><a name="l00440"></a><span class="lineno"><a class="line" href="classmy__allocator.html#ac682ce1ad46490b5e08f7a2a01b6cf2a">  440</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classmy__allocator.html#ac682ce1ad46490b5e08f7a2a01b6cf2a">construct</a> (pointer p, const_reference v) {</div><div class="line"><a name="l00441"></a><span class="lineno">  441</span>&#160;        <span class="keyword">new</span> (p) T(v);                               <span class="comment">// this is correct and exempt</span></div><div class="line"><a name="l00442"></a><span class="lineno">  442</span>&#160;        assert(valid());</div><div class="line"><a name="l00443"></a><span class="lineno">  443</span>&#160;    }                           <span class="comment">// from the prohibition of new</span></div><div class="line"><a name="l00444"></a><span class="lineno">  444</span>&#160;</div><div class="line"><a name="l00445"></a><span class="lineno">  445</span>&#160;    <span class="comment">// ----------</span></div><div class="line"><a name="l00446"></a><span class="lineno">  446</span>&#160;    <span class="comment">// deallocate</span></div><div class="line"><a name="l00447"></a><span class="lineno">  447</span>&#160;    <span class="comment">// ----------</span></div><div class="line"><a name="l00448"></a><span class="lineno">  448</span>&#160;</div><div class="line"><a name="l00459"></a><span class="lineno"><a class="line" href="classmy__allocator.html#a0fd86d645b3ced3ff4188b983a9b90ec">  459</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classmy__allocator.html#a0fd86d645b3ced3ff4188b983a9b90ec">deallocate</a> (pointer ptr, size_type num_objects) {</div><div class="line"><a name="l00460"></a><span class="lineno">  460</span>&#160;</div><div class="line"><a name="l00461"></a><span class="lineno">  461</span>&#160;        <span class="keywordtype">int</span>* p = (<span class="keywordtype">int</span>*)ptr;</div><div class="line"><a name="l00462"></a><span class="lineno">  462</span>&#160;        <span class="comment">// take one byte off ptr to retrieve first sentinel address</span></div><div class="line"><a name="l00463"></a><span class="lineno">  463</span>&#160;    p -= 1;</div><div class="line"><a name="l00464"></a><span class="lineno">  464</span>&#160;</div><div class="line"><a name="l00465"></a><span class="lineno">  465</span>&#160;        <span class="comment">// find block passed in</span></div><div class="line"><a name="l00466"></a><span class="lineno">  466</span>&#160;        <a class="code" href="classmy__allocator_1_1iterator.html">iterator</a> block = <a class="code" href="classmy__allocator.html#a0d633e247b8093a96a1fd7d71fe0a6ab">i_begin</a>();</div><div class="line"><a name="l00467"></a><span class="lineno">  467</span>&#160;        <span class="keywordflow">for</span> (block; block != <a class="code" href="classmy__allocator.html#a83f5d94cab506e1f9858c24f3eaadbd4">i_end</a>(); ++block) {</div><div class="line"><a name="l00468"></a><span class="lineno">  468</span>&#160;            <span class="keywordflow">if</span> (&amp;(*block) == p) {</div><div class="line"><a name="l00469"></a><span class="lineno">  469</span>&#160;                <span class="keywordflow">break</span>;</div><div class="line"><a name="l00470"></a><span class="lineno">  470</span>&#160;            }</div><div class="line"><a name="l00471"></a><span class="lineno">  471</span>&#160;        }</div><div class="line"><a name="l00472"></a><span class="lineno">  472</span>&#160;</div><div class="line"><a name="l00473"></a><span class="lineno">  473</span>&#160;        <span class="comment">// throw error if not found of if trying to deallocate free block</span></div><div class="line"><a name="l00474"></a><span class="lineno">  474</span>&#160;        <span class="keywordflow">if</span> (block == <a class="code" href="classmy__allocator.html#a83f5d94cab506e1f9858c24f3eaadbd4">i_end</a>() || *block &gt; 0)</div><div class="line"><a name="l00475"></a><span class="lineno">  475</span>&#160;        {</div><div class="line"><a name="l00476"></a><span class="lineno">  476</span>&#160;            <span class="keywordflow">throw</span> std::invalid_argument(<span class="stringliteral">&quot;invalid pointer&quot;</span>);</div><div class="line"><a name="l00477"></a><span class="lineno">  477</span>&#160;        }</div><div class="line"><a name="l00478"></a><span class="lineno">  478</span>&#160;    </div><div class="line"><a name="l00479"></a><span class="lineno">  479</span>&#160;    assert (block != <a class="code" href="classmy__allocator.html#a83f5d94cab506e1f9858c24f3eaadbd4">i_end</a>() &amp;&amp; *block &lt; 0);</div><div class="line"><a name="l00480"></a><span class="lineno">  480</span>&#160;</div><div class="line"><a name="l00481"></a><span class="lineno">  481</span>&#160;        <span class="comment">// free current block + set temp to prev block</span></div><div class="line"><a name="l00482"></a><span class="lineno">  482</span>&#160;        set_sentinels(block, *block * -1);</div><div class="line"><a name="l00483"></a><span class="lineno">  483</span>&#160;        ++block;</div><div class="line"><a name="l00484"></a><span class="lineno">  484</span>&#160;        <a class="code" href="classmy__allocator_1_1iterator.html">iterator</a> temp = block;</div><div class="line"><a name="l00485"></a><span class="lineno">  485</span>&#160;        --block;</div><div class="line"><a name="l00486"></a><span class="lineno">  486</span>&#160;</div><div class="line"><a name="l00487"></a><span class="lineno">  487</span>&#160;        <span class="comment">// if the next block is free and not the end block, merge forward</span></div><div class="line"><a name="l00488"></a><span class="lineno">  488</span>&#160;        <span class="keywordflow">if</span> ((block != (--<a class="code" href="classmy__allocator.html#a83f5d94cab506e1f9858c24f3eaadbd4">i_end</a>())) &amp;&amp; (*(temp) &gt; 0))</div><div class="line"><a name="l00489"></a><span class="lineno">  489</span>&#160;        {</div><div class="line"><a name="l00490"></a><span class="lineno">  490</span>&#160;            set_sentinels(block, *block + *temp + SENTINEL_SIZE);</div><div class="line"><a name="l00491"></a><span class="lineno">  491</span>&#160;        assert (*block &gt; 0 &amp;&amp; *temp &gt; 0);</div><div class="line"><a name="l00492"></a><span class="lineno">  492</span>&#160;        }</div><div class="line"><a name="l00493"></a><span class="lineno">  493</span>&#160;</div><div class="line"><a name="l00494"></a><span class="lineno">  494</span>&#160;        <span class="comment">//if we are not the begin block</span></div><div class="line"><a name="l00495"></a><span class="lineno">  495</span>&#160;        <span class="keywordflow">if</span> (block != <a class="code" href="classmy__allocator.html#a0d633e247b8093a96a1fd7d71fe0a6ab">i_begin</a>()) {</div><div class="line"><a name="l00496"></a><span class="lineno">  496</span>&#160;            <span class="comment">// checking prev block now</span></div><div class="line"><a name="l00497"></a><span class="lineno">  497</span>&#160;        --block;</div><div class="line"><a name="l00498"></a><span class="lineno">  498</span>&#160;            temp = block;</div><div class="line"><a name="l00499"></a><span class="lineno">  499</span>&#160;            ++block;</div><div class="line"><a name="l00500"></a><span class="lineno">  500</span>&#160;            <span class="comment">//if prev block is free</span></div><div class="line"><a name="l00501"></a><span class="lineno">  501</span>&#160;            <span class="keywordflow">if</span> (*(temp) &gt; 0) {</div><div class="line"><a name="l00502"></a><span class="lineno">  502</span>&#160;                <span class="comment">//add size to current block and &#39;delete&#39; previous block</span></div><div class="line"><a name="l00503"></a><span class="lineno">  503</span>&#160;                set_sentinels(temp, *block + *temp + SENTINEL_SIZE);</div><div class="line"><a name="l00504"></a><span class="lineno">  504</span>&#160;                block = temp;</div><div class="line"><a name="l00505"></a><span class="lineno">  505</span>&#160;        assert (*block &gt; 0);</div><div class="line"><a name="l00506"></a><span class="lineno">  506</span>&#160;            }</div><div class="line"><a name="l00507"></a><span class="lineno">  507</span>&#160;        }</div><div class="line"><a name="l00508"></a><span class="lineno">  508</span>&#160;        assert(valid());</div><div class="line"><a name="l00509"></a><span class="lineno">  509</span>&#160;    }</div><div class="line"><a name="l00510"></a><span class="lineno">  510</span>&#160;    </div><div class="line"><a name="l00511"></a><span class="lineno">  511</span>&#160;    <span class="comment">// -------</span></div><div class="line"><a name="l00512"></a><span class="lineno">  512</span>&#160;    <span class="comment">// destroy</span></div><div class="line"><a name="l00513"></a><span class="lineno">  513</span>&#160;    <span class="comment">// -------</span></div><div class="line"><a name="l00514"></a><span class="lineno">  514</span>&#160;</div><div class="line"><a name="l00519"></a><span class="lineno"><a class="line" href="classmy__allocator.html#a5e208c763aa3c6c31e298fc96de4a37a">  519</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classmy__allocator.html#a5e208c763aa3c6c31e298fc96de4a37a">destroy</a> (pointer p) {</div><div class="line"><a name="l00520"></a><span class="lineno">  520</span>&#160;        p-&gt;~T();               <span class="comment">// this is correct</span></div><div class="line"><a name="l00521"></a><span class="lineno">  521</span>&#160;        assert(valid());</div><div class="line"><a name="l00522"></a><span class="lineno">  522</span>&#160;    }</div><div class="line"><a name="l00523"></a><span class="lineno">  523</span>&#160;</div><div class="line"><a name="l00524"></a><span class="lineno">  524</span>&#160;    <span class="comment">// -----------</span></div><div class="line"><a name="l00525"></a><span class="lineno">  525</span>&#160;    <span class="comment">// operator []</span></div><div class="line"><a name="l00526"></a><span class="lineno">  526</span>&#160;    <span class="comment">// -----------</span></div><div class="line"><a name="l00527"></a><span class="lineno">  527</span>&#160;</div><div class="line"><a name="l00532"></a><span class="lineno"><a class="line" href="classmy__allocator.html#afce70a1babca1d1ed59b595cb44818cf">  532</a></span>&#160;    <span class="keywordtype">int</span>&amp; <a class="code" href="classmy__allocator.html#afce70a1babca1d1ed59b595cb44818cf">operator [] </a>(<span class="keywordtype">int</span> i) {</div><div class="line"><a name="l00533"></a><span class="lineno">  533</span>&#160;        <span class="keywordflow">return</span> *<span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">int</span>*<span class="keyword">&gt;</span>(&amp;a[i]);</div><div class="line"><a name="l00534"></a><span class="lineno">  534</span>&#160;    }</div><div class="line"><a name="l00535"></a><span class="lineno">  535</span>&#160;</div><div class="line"><a name="l00540"></a><span class="lineno"><a class="line" href="classmy__allocator.html#a449c644c9fe5f4e832443fac06716c94">  540</a></span>&#160;    <span class="keyword">const</span> <span class="keywordtype">int</span>&amp; <a class="code" href="classmy__allocator.html#afce70a1babca1d1ed59b595cb44818cf">operator [] </a>(<span class="keywordtype">int</span> i)<span class="keyword"> const </span>{</div><div class="line"><a name="l00541"></a><span class="lineno">  541</span>&#160;        <span class="keywordflow">return</span> *<span class="keyword">reinterpret_cast&lt;</span><span class="keyword">const </span><span class="keywordtype">int</span>*<span class="keyword">&gt;</span>(&amp;a[i]);</div><div class="line"><a name="l00542"></a><span class="lineno">  542</span>&#160;    }</div><div class="line"><a name="l00543"></a><span class="lineno">  543</span>&#160;</div><div class="line"><a name="l00544"></a><span class="lineno">  544</span>&#160;    <span class="comment">// -----</span></div><div class="line"><a name="l00545"></a><span class="lineno">  545</span>&#160;    <span class="comment">// begin</span></div><div class="line"><a name="l00546"></a><span class="lineno">  546</span>&#160;    <span class="comment">// -----</span></div><div class="line"><a name="l00547"></a><span class="lineno">  547</span>&#160;</div><div class="line"><a name="l00552"></a><span class="lineno"><a class="line" href="classmy__allocator.html#a0d633e247b8093a96a1fd7d71fe0a6ab">  552</a></span>&#160;    <a class="code" href="classmy__allocator_1_1iterator.html">iterator</a> <a class="code" href="classmy__allocator.html#a0d633e247b8093a96a1fd7d71fe0a6ab">i_begin</a> () {</div><div class="line"><a name="l00553"></a><span class="lineno">  553</span>&#160;        <span class="keywordflow">return</span> <a class="code" href="classmy__allocator_1_1iterator.html">iterator</a>(&amp;(*<span class="keyword">this</span>)[0]);</div><div class="line"><a name="l00554"></a><span class="lineno">  554</span>&#160;    }</div><div class="line"><a name="l00555"></a><span class="lineno">  555</span>&#160;</div><div class="line"><a name="l00560"></a><span class="lineno"><a class="line" href="classmy__allocator.html#ada82835ca637793860c0aededc479c88">  560</a></span>&#160;    <a class="code" href="classmy__allocator_1_1const__iterator.html">const_iterator</a> <a class="code" href="classmy__allocator.html#ada82835ca637793860c0aededc479c88">c_begin</a> ()<span class="keyword"> const </span>{</div><div class="line"><a name="l00561"></a><span class="lineno">  561</span>&#160;        <span class="keywordflow">return</span> <a class="code" href="classmy__allocator_1_1const__iterator.html">const_iterator</a>(&amp;(*<span class="keyword">this</span>)[0]);</div><div class="line"><a name="l00562"></a><span class="lineno">  562</span>&#160;    }</div><div class="line"><a name="l00563"></a><span class="lineno">  563</span>&#160;</div><div class="line"><a name="l00564"></a><span class="lineno">  564</span>&#160;    <span class="comment">// ---</span></div><div class="line"><a name="l00565"></a><span class="lineno">  565</span>&#160;    <span class="comment">// end</span></div><div class="line"><a name="l00566"></a><span class="lineno">  566</span>&#160;    <span class="comment">// ---</span></div><div class="line"><a name="l00567"></a><span class="lineno">  567</span>&#160;</div><div class="line"><a name="l00572"></a><span class="lineno"><a class="line" href="classmy__allocator.html#a83f5d94cab506e1f9858c24f3eaadbd4">  572</a></span>&#160;    <a class="code" href="classmy__allocator_1_1iterator.html">iterator</a> <a class="code" href="classmy__allocator.html#a83f5d94cab506e1f9858c24f3eaadbd4">i_end</a> () {</div><div class="line"><a name="l00573"></a><span class="lineno">  573</span>&#160;        <span class="keywordflow">return</span> <a class="code" href="classmy__allocator_1_1iterator.html">iterator</a>(&amp;(*<span class="keyword">this</span>)[N]);</div><div class="line"><a name="l00574"></a><span class="lineno">  574</span>&#160;    }</div><div class="line"><a name="l00575"></a><span class="lineno">  575</span>&#160;</div><div class="line"><a name="l00580"></a><span class="lineno"><a class="line" href="classmy__allocator.html#a4fd52159becc17ad21754ad0cc8dcff5">  580</a></span>&#160;    <a class="code" href="classmy__allocator_1_1const__iterator.html">const_iterator</a> <a class="code" href="classmy__allocator.html#a4fd52159becc17ad21754ad0cc8dcff5">c_end</a> ()<span class="keyword"> const </span>{</div><div class="line"><a name="l00581"></a><span class="lineno">  581</span>&#160;        <span class="keywordflow">return</span> <a class="code" href="classmy__allocator_1_1const__iterator.html">const_iterator</a>(&amp;(*<span class="keyword">this</span>)[N]);</div><div class="line"><a name="l00582"></a><span class="lineno">  582</span>&#160;    }</div><div class="line"><a name="l00583"></a><span class="lineno">  583</span>&#160;};</div><div class="line"><a name="l00584"></a><span class="lineno">  584</span>&#160;</div><div class="line"><a name="l00585"></a><span class="lineno">  585</span>&#160;<span class="preprocessor">#endif // Allocator_h</span></div><div class="ttc" id="classmy__allocator_html_ae072d6037f9f72b54303533033ed188d"><div class="ttname"><a href="classmy__allocator.html#ae072d6037f9f72b54303533033ed188d">my_allocator::my_allocator</a></div><div class="ttdeci">my_allocator()</div><div class="ttdef"><b>Definition:</b> Allocator.hpp:307</div></div>
<div class="ttc" id="classmy__allocator_html_afce70a1babca1d1ed59b595cb44818cf"><div class="ttname"><a href="classmy__allocator.html#afce70a1babca1d1ed59b595cb44818cf">my_allocator::operator[]</a></div><div class="ttdeci">int &amp; operator[](int i)</div><div class="ttdef"><b>Definition:</b> Allocator.hpp:532</div></div>
<div class="ttc" id="classmy__allocator_html_ac682ce1ad46490b5e08f7a2a01b6cf2a"><div class="ttname"><a href="classmy__allocator.html#ac682ce1ad46490b5e08f7a2a01b6cf2a">my_allocator::construct</a></div><div class="ttdeci">void construct(pointer p, const_reference v)</div><div class="ttdef"><b>Definition:</b> Allocator.hpp:440</div></div>
<div class="ttc" id="classmy__allocator_html"><div class="ttname"><a href="classmy__allocator.html">my_allocator</a></div><div class="ttdef"><b>Definition:</b> Allocator.hpp:23</div></div>
<div class="ttc" id="classmy__allocator_1_1const__iterator_html"><div class="ttname"><a href="classmy__allocator_1_1const__iterator.html">my_allocator::const_iterator</a></div><div class="ttdef"><b>Definition:</b> Allocator.hpp:167</div></div>
<div class="ttc" id="classmy__allocator_html_a4fd52159becc17ad21754ad0cc8dcff5"><div class="ttname"><a href="classmy__allocator.html#a4fd52159becc17ad21754ad0cc8dcff5">my_allocator::c_end</a></div><div class="ttdeci">const_iterator c_end() const</div><div class="ttdef"><b>Definition:</b> Allocator.hpp:580</div></div>
<div class="ttc" id="classmy__allocator_html_a5e208c763aa3c6c31e298fc96de4a37a"><div class="ttname"><a href="classmy__allocator.html#a5e208c763aa3c6c31e298fc96de4a37a">my_allocator::destroy</a></div><div class="ttdeci">void destroy(pointer p)</div><div class="ttdef"><b>Definition:</b> Allocator.hpp:519</div></div>
<div class="ttc" id="classmy__allocator_html_ac2bd3b32769707802cb8ff29f4c257bc"><div class="ttname"><a href="classmy__allocator.html#ac2bd3b32769707802cb8ff29f4c257bc">my_allocator::allocate</a></div><div class="ttdeci">pointer allocate(size_type num_objects)</div><div class="ttdef"><b>Definition:</b> Allocator.hpp:364</div></div>
<div class="ttc" id="classmy__allocator_1_1iterator_html"><div class="ttname"><a href="classmy__allocator_1_1iterator.html">my_allocator::iterator</a></div><div class="ttdef"><b>Definition:</b> Allocator.hpp:61</div></div>
<div class="ttc" id="classmy__allocator_html_a0d633e247b8093a96a1fd7d71fe0a6ab"><div class="ttname"><a href="classmy__allocator.html#a0d633e247b8093a96a1fd7d71fe0a6ab">my_allocator::i_begin</a></div><div class="ttdeci">iterator i_begin()</div><div class="ttdef"><b>Definition:</b> Allocator.hpp:552</div></div>
<div class="ttc" id="classmy__allocator_html_ada82835ca637793860c0aededc479c88"><div class="ttname"><a href="classmy__allocator.html#ada82835ca637793860c0aededc479c88">my_allocator::c_begin</a></div><div class="ttdeci">const_iterator c_begin() const</div><div class="ttdef"><b>Definition:</b> Allocator.hpp:560</div></div>
<div class="ttc" id="classmy__allocator_html_a83f5d94cab506e1f9858c24f3eaadbd4"><div class="ttname"><a href="classmy__allocator.html#a83f5d94cab506e1f9858c24f3eaadbd4">my_allocator::i_end</a></div><div class="ttdeci">iterator i_end()</div><div class="ttdef"><b>Definition:</b> Allocator.hpp:572</div></div>
<div class="ttc" id="classmy__allocator_html_a0fd86d645b3ced3ff4188b983a9b90ec"><div class="ttname"><a href="classmy__allocator.html#a0fd86d645b3ced3ff4188b983a9b90ec">my_allocator::deallocate</a></div><div class="ttdeci">void deallocate(pointer ptr, size_type num_objects)</div><div class="ttdef"><b>Definition:</b> Allocator.hpp:459</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
